/* This file was generated by SableCC (http://www.sablecc.org/). */

package promela.lexer;

import java.io.*;
import promela.node.*;

@SuppressWarnings("nls")
public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    @SuppressWarnings("unused")
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    public Lexer(@SuppressWarnings("hiding") PushbackReader in)
    {
        this.in = in;
    }
 
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.token = getToken();
            filter();
        }

        return this.token;
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.token = getToken();
            filter();
        }

        Token result = this.token;
        this.token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        @SuppressWarnings("hiding") int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
        @SuppressWarnings("hiding") int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            @SuppressWarnings("hiding") Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            @SuppressWarnings("hiding") Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            @SuppressWarnings("hiding") Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            @SuppressWarnings("hiding") Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            @SuppressWarnings("hiding") Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            @SuppressWarnings("hiding") Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            @SuppressWarnings("hiding") Token token = new6(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            @SuppressWarnings("hiding") Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            @SuppressWarnings("hiding") Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            @SuppressWarnings("hiding") Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            @SuppressWarnings("hiding") Token token = new10(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            @SuppressWarnings("hiding") Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            @SuppressWarnings("hiding") Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            @SuppressWarnings("hiding") Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            @SuppressWarnings("hiding") Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            @SuppressWarnings("hiding") Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            @SuppressWarnings("hiding") Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            @SuppressWarnings("hiding") Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            @SuppressWarnings("hiding") Token token = new18(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            @SuppressWarnings("hiding") Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            @SuppressWarnings("hiding") Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            @SuppressWarnings("hiding") Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            @SuppressWarnings("hiding") Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            @SuppressWarnings("hiding") Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                            @SuppressWarnings("hiding") Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                            @SuppressWarnings("hiding") Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                            @SuppressWarnings("hiding") Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                            @SuppressWarnings("hiding") Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                            @SuppressWarnings("hiding") Token token = new28(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                            @SuppressWarnings("hiding") Token token = new29(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                            @SuppressWarnings("hiding") Token token = new30(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                            @SuppressWarnings("hiding") Token token = new31(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                            @SuppressWarnings("hiding") Token token = new32(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                            @SuppressWarnings("hiding") Token token = new33(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                            @SuppressWarnings("hiding") Token token = new34(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 35:
                        {
                            @SuppressWarnings("hiding") Token token = new35(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 36:
                        {
                            @SuppressWarnings("hiding") Token token = new36(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 37:
                        {
                            @SuppressWarnings("hiding") Token token = new37(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 38:
                        {
                            @SuppressWarnings("hiding") Token token = new38(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 39:
                        {
                            @SuppressWarnings("hiding") Token token = new39(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 40:
                        {
                            @SuppressWarnings("hiding") Token token = new40(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 41:
                        {
                            @SuppressWarnings("hiding") Token token = new41(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 42:
                        {
                            @SuppressWarnings("hiding") Token token = new42(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 43:
                        {
                            @SuppressWarnings("hiding") Token token = new43(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 44:
                        {
                            @SuppressWarnings("hiding") Token token = new44(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 45:
                        {
                            @SuppressWarnings("hiding") Token token = new45(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 46:
                        {
                            @SuppressWarnings("hiding") Token token = new46(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 47:
                        {
                            @SuppressWarnings("hiding") Token token = new47(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 48:
                        {
                            @SuppressWarnings("hiding") Token token = new48(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 49:
                        {
                            @SuppressWarnings("hiding") Token token = new49(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 50:
                        {
                            @SuppressWarnings("hiding") Token token = new50(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 51:
                        {
                            @SuppressWarnings("hiding") Token token = new51(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 52:
                        {
                            @SuppressWarnings("hiding") Token token = new52(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 53:
                        {
                            @SuppressWarnings("hiding") Token token = new53(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 54:
                        {
                            @SuppressWarnings("hiding") Token token = new54(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 55:
                        {
                            @SuppressWarnings("hiding") Token token = new55(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 56:
                        {
                            @SuppressWarnings("hiding") Token token = new56(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 57:
                        {
                            @SuppressWarnings("hiding") Token token = new57(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 58:
                        {
                            @SuppressWarnings("hiding") Token token = new58(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 59:
                        {
                            @SuppressWarnings("hiding") Token token = new59(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 60:
                        {
                            @SuppressWarnings("hiding") Token token = new60(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 61:
                        {
                            @SuppressWarnings("hiding") Token token = new61(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 62:
                        {
                            @SuppressWarnings("hiding") Token token = new62(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 63:
                        {
                            @SuppressWarnings("hiding") Token token = new63(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 64:
                        {
                            @SuppressWarnings("hiding") Token token = new64(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 65:
                        {
                            @SuppressWarnings("hiding") Token token = new65(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 66:
                        {
                            @SuppressWarnings("hiding") Token token = new66(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 67:
                        {
                            @SuppressWarnings("hiding") Token token = new67(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 68:
                        {
                            @SuppressWarnings("hiding") Token token = new68(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 69:
                        {
                            @SuppressWarnings("hiding") Token token = new69(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 70:
                        {
                            @SuppressWarnings("hiding") Token token = new70(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 71:
                        {
                            @SuppressWarnings("hiding") Token token = new71(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 72:
                        {
                            @SuppressWarnings("hiding") Token token = new72(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 73:
                        {
                            @SuppressWarnings("hiding") Token token = new73(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 74:
                        {
                            @SuppressWarnings("hiding") Token token = new74(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 75:
                        {
                            @SuppressWarnings("hiding") Token token = new75(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 76:
                        {
                            @SuppressWarnings("hiding") Token token = new76(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 77:
                        {
                            @SuppressWarnings("hiding") Token token = new77(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 78:
                        {
                            @SuppressWarnings("hiding") Token token = new78(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 79:
                        {
                            @SuppressWarnings("hiding") Token token = new79(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 80:
                        {
                            @SuppressWarnings("hiding") Token token = new80(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 81:
                        {
                            @SuppressWarnings("hiding") Token token = new81(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 82:
                        {
                            @SuppressWarnings("hiding") Token token = new82(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 83:
                        {
                            @SuppressWarnings("hiding") Token token = new83(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 84:
                        {
                            @SuppressWarnings("hiding") Token token = new84(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 85:
                        {
                            @SuppressWarnings("hiding") Token token = new85(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 86:
                        {
                            @SuppressWarnings("hiding") Token token = new86(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 87:
                        {
                            @SuppressWarnings("hiding") Token token = new87(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 88:
                        {
                            @SuppressWarnings("hiding") Token token = new88(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 89:
                        {
                            @SuppressWarnings("hiding") Token token = new89(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 90:
                        {
                            @SuppressWarnings("hiding") Token token = new90(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 91:
                        {
                            @SuppressWarnings("hiding") Token token = new91(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 92:
                        {
                            @SuppressWarnings("hiding") Token token = new92(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 93:
                        {
                            @SuppressWarnings("hiding") Token token = new93(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 94:
                        {
                            @SuppressWarnings("hiding") Token token = new94(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 95:
                        {
                            @SuppressWarnings("hiding") Token token = new95(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                    @SuppressWarnings("hiding") EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TWhiteSpace(text, line, pos); }
    Token new1(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TTraditionalComment(text, line, pos); }
    Token new2(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TEndOfLineComment(text, line, pos); }
    Token new3(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TNumber(text, line, pos); }
    Token new4(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TBang(line, pos); }
    Token new5(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TComplement(line, pos); }
    Token new6(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TMultop(text, line, pos); }
    Token new7(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TPlus(line, pos); }
    Token new8(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TMinus(line, pos); }
    Token new9(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TShiftop(text, line, pos); }
    Token new10(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TEqop(text, line, pos); }
    Token new11(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TBitand(line, pos); }
    Token new12(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TBitor(line, pos); }
    Token new13(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TBitxor(line, pos); }
    Token new14(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TAnd(line, pos); }
    Token new15(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TOr(line, pos); }
    Token new16(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TLt(line, pos); }
    Token new17(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TGt(line, pos); }
    Token new18(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TRelop(text, line, pos); }
    Token new19(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TLParenthese(line, pos); }
    Token new20(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TRParenthese(line, pos); }
    Token new21(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TLBrace(line, pos); }
    Token new22(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TRBrace(line, pos); }
    Token new23(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TLBracket(line, pos); }
    Token new24(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TRBracket(line, pos); }
    Token new25(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TSemicolon(line, pos); }
    Token new26(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TNumberSign(line, pos); }
    Token new27(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TComma(line, pos); }
    Token new28(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TDot(line, pos); }
    Token new29(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TAssign(line, pos); }
    Token new30(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TColonColon(line, pos); }
    Token new31(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TColon(line, pos); }
    Token new32(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TPlusPlus(line, pos); }
    Token new33(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TMinusMinus(line, pos); }
    Token new34(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TRightarrow(line, pos); }
    Token new35(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TBangBang(line, pos); }
    Token new36(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TQueryQuery(line, pos); }
    Token new37(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TQuery(line, pos); }
    Token new38(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TUnderscore(line, pos); }
    Token new39(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TQuotes(line, pos); }
    Token new40(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TAt(line, pos); }
    Token new41(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TApostrophe(line, pos); }
    Token new42(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TBackslash(line, pos); }
    Token new43(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TActivetok(line, pos); }
    Token new44(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TAssert(line, pos); }
    Token new45(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TAtomic(line, pos); }
    Token new46(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TBit(line, pos); }
    Token new47(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TBool(line, pos); }
    Token new48(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TBreak(line, pos); }
    Token new49(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TByte(line, pos); }
    Token new50(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TChanop(text, line, pos); }
    Token new51(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TChan(line, pos); }
    Token new52(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TDStep(line, pos); }
    Token new53(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TDo(line, pos); }
    Token new54(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TElse(line, pos); }
    Token new55(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TEnabled(line, pos); }
    Token new56(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TEval(line, pos); }
    Token new57(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TFalse(line, pos); }
    Token new58(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TFi(line, pos); }
    Token new59(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TGoto(line, pos); }
    Token new60(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new THidden(line, pos); }
    Token new61(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TIf(line, pos); }
    Token new62(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TInittok(line, pos); }
    Token new63(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TInt(line, pos); }
    Token new64(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TLen(line, pos); }
    Token new65(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TMtypetok(line, pos); }
    Token new66(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TNevertok(line, pos); }
    Token new67(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TNotrace(line, pos); }
    Token new68(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TNp(line, pos); }
    Token new69(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TOd(line, pos); }
    Token new70(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TOf(line, pos); }
    Token new71(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TPcValue(line, pos); }
    Token new72(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TPid(line, pos); }
    Token new73(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TPrintf(line, pos); }
    Token new74(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TPrintm(line, pos); }
    Token new75(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TPrioritytok(line, pos); }
    Token new76(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TProcessid(line, pos); }
    Token new77(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TNrPr(line, pos); }
    Token new78(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TInlinetok(line, pos); }
    Token new79(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TProctypetok(line, pos); }
    Token new80(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TProvided(line, pos); }
    Token new81(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TRun(line, pos); }
    Token new82(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TShort(line, pos); }
    Token new83(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TShow(line, pos); }
    Token new84(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TSkip(line, pos); }
    Token new85(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TTimeout(line, pos); }
    Token new86(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TTracetok(line, pos); }
    Token new87(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TTrue(line, pos); }
    Token new88(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TTypedef(line, pos); }
    Token new89(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TUnless(line, pos); }
    Token new90(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TUnsigned(line, pos); }
    Token new91(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TXr(line, pos); }
    Token new92(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TXs(line, pos); }
    Token new93(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TName(text, line, pos); }
    Token new94(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TByteliteral(text, line, pos); }
    Token new95(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TString(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(@SuppressWarnings("hiding") Token token) throws IOException
    {
        @SuppressWarnings("hiding") String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{0, 8, 1}, {9, 9, 2}, {10, 10, 3}, {11, 11, 1}, {12, 12, 4}, {13, 13, 5}, {14, 31, 1}, {32, 32, 6}, {33, 33, 7}, {34, 34, 8}, {35, 35, 9}, {36, 36, 1}, {37, 37, 10}, {38, 38, 11}, {39, 39, 12}, {40, 40, 13}, {41, 41, 14}, {42, 42, 15}, {43, 43, 16}, {44, 44, 17}, {45, 45, 18}, {46, 46, 19}, {47, 47, 20}, {48, 57, 21}, {58, 58, 22}, {59, 59, 23}, {60, 60, 24}, {61, 61, 25}, {62, 62, 26}, {63, 63, 27}, {64, 64, 28}, {65, 90, 29}, {91, 91, 30}, {92, 92, 31}, {93, 93, 32}, {94, 94, 33}, {95, 95, 34}, {96, 96, 1}, {97, 97, 35}, {98, 98, 36}, {99, 99, 37}, {100, 100, 38}, {101, 101, 39}, {102, 102, 40}, {103, 103, 41}, {104, 104, 42}, {105, 105, 43}, {106, 107, 29}, {108, 108, 44}, {109, 109, 45}, {110, 110, 46}, {111, 111, 47}, {112, 112, 48}, {113, 113, 29}, {114, 114, 49}, {115, 115, 50}, {116, 116, 51}, {117, 117, 52}, {118, 119, 29}, {120, 120, 53}, {121, 122, 29}, {123, 123, 54}, {124, 124, 55}, {125, 125, 56}, {126, 126, 57}, {127, 255, 1}, },
            {},
            {{9, 9, 58}, {10, 10, 59}, {12, 12, 60}, {13, 13, 61}, {32, 32, 62}, },
            {{9, 32, -4}, },
            {{9, 32, -4}, },
            {{9, 9, 58}, {10, 10, 63}, {12, 32, -4}, },
            {{9, 32, -4}, },
            {{33, 33, 64}, {61, 61, 65}, },
            {{0, 33, 66}, {34, 34, 67}, {35, 65535, 66}, },
            {},
            {},
            {{38, 38, 68}, },
            {},
            {},
            {},
            {},
            {{43, 43, 69}, },
            {},
            {{45, 45, 70}, {62, 62, 71}, },
            {},
            {{42, 42, 72}, {47, 47, 73}, },
            {{48, 57, 74}, },
            {{58, 58, 75}, },
            {},
            {{60, 60, 76}, {61, 61, 77}, },
            {{61, 61, 78}, },
            {{61, 61, 79}, {62, 62, 80}, },
            {{63, 63, 81}, },
            {},
            {{48, 57, 82}, {65, 90, 83}, {95, 95, 84}, {97, 122, 83}, },
            {},
            {},
            {},
            {},
            {{110, 110, 85}, {112, 112, 86}, },
            {{48, 95, -31}, {97, 98, 83}, {99, 99, 87}, {100, 114, 83}, {115, 115, 88}, {116, 116, 89}, {117, 122, 83}, },
            {{48, 95, -31}, {97, 104, 83}, {105, 105, 90}, {106, 110, 83}, {111, 111, 91}, {112, 113, 83}, {114, 114, 92}, {115, 120, 83}, {121, 121, 93}, {122, 122, 83}, },
            {{48, 95, -31}, {97, 103, 83}, {104, 104, 94}, {105, 122, 83}, },
            {{48, 90, -31}, {95, 95, 95}, {97, 110, 83}, {111, 111, 96}, {112, 122, 83}, },
            {{48, 95, -31}, {97, 107, 83}, {108, 108, 97}, {109, 109, 98}, {110, 110, 99}, {111, 117, 83}, {118, 118, 100}, {119, 122, 83}, },
            {{48, 95, -31}, {97, 97, 101}, {98, 104, 83}, {105, 105, 102}, {106, 116, 83}, {117, 117, 103}, {118, 122, 83}, },
            {{48, 95, -31}, {97, 110, 83}, {111, 111, 104}, {112, 122, 83}, },
            {{48, 104, -38}, {105, 105, 105}, {106, 122, 83}, },
            {{48, 95, -31}, {97, 101, 83}, {102, 102, 106}, {103, 109, 83}, {110, 110, 107}, {111, 122, 83}, },
            {{48, 95, -31}, {97, 100, 83}, {101, 101, 108}, {102, 122, 83}, },
            {{48, 95, -31}, {97, 115, 83}, {116, 116, 109}, {117, 122, 83}, },
            {{48, 100, -46}, {101, 101, 110}, {102, 102, 111}, {103, 110, 83}, {111, 111, 112}, {112, 112, 113}, {113, 122, 83}, },
            {{48, 95, -31}, {97, 99, 83}, {100, 100, 114}, {101, 101, 83}, {102, 102, 115}, {103, 122, 83}, },
            {{48, 98, -37}, {99, 99, 116}, {100, 104, 83}, {105, 105, 117}, {106, 113, 83}, {114, 114, 118}, {115, 122, 83}, },
            {{48, 95, -31}, {97, 116, 83}, {117, 117, 119}, {118, 122, 83}, },
            {{48, 103, -39}, {104, 104, 120}, {105, 106, 83}, {107, 107, 121}, {108, 122, 83}, },
            {{48, 104, -38}, {105, 105, 122}, {106, 113, 83}, {114, 114, 123}, {115, 120, 83}, {121, 121, 124}, {122, 122, 83}, },
            {{48, 95, -31}, {97, 109, 83}, {110, 110, 125}, {111, 122, 83}, },
            {{48, 95, -31}, {97, 113, 83}, {114, 114, 126}, {115, 115, 127}, {116, 122, 83}, },
            {},
            {{124, 124, 128}, },
            {},
            {},
            {{9, 32, -4}, },
            {{9, 32, -4}, },
            {{9, 32, -4}, },
            {{9, 32, -7}, },
            {{9, 32, -4}, },
            {{9, 32, -4}, },
            {},
            {},
            {{0, 65535, -10}, },
            {},
            {},
            {},
            {},
            {},
            {{0, 9, 129}, {10, 10, 130}, {11, 12, 129}, {13, 13, 131}, {14, 41, 129}, {42, 42, 132}, {43, 65535, 129}, },
            {{0, 9, 133}, {10, 10, 134}, {11, 12, 133}, {13, 13, 135}, {14, 65535, 133}, },
            {{48, 57, 74}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{114, 114, 136}, },
            {{105, 105, 137}, },
            {{48, 115, -47}, {116, 116, 138}, {117, 122, 83}, },
            {{48, 95, -31}, {97, 114, 83}, {115, 115, 139}, {116, 122, 83}, },
            {{48, 110, -43}, {111, 111, 140}, {112, 122, 83}, },
            {{48, 115, -47}, {116, 116, 141}, {117, 122, 83}, },
            {{48, 110, -43}, {111, 111, 142}, {112, 122, 83}, },
            {{48, 100, -46}, {101, 101, 143}, {102, 122, 83}, },
            {{48, 115, -47}, {116, 116, 144}, {117, 122, 83}, },
            {{48, 95, -31}, {97, 97, 145}, {98, 122, 83}, },
            {{48, 114, -90}, {115, 115, 146}, {116, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 114, -90}, {115, 115, 147}, {116, 122, 83}, },
            {{48, 95, -31}, {97, 111, 83}, {112, 112, 148}, {113, 122, 83}, },
            {{48, 95, -31}, {97, 97, 149}, {98, 122, 83}, },
            {{48, 95, -31}, {97, 97, 150}, {98, 122, 83}, },
            {{48, 107, -41}, {108, 108, 151}, {109, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 107, -41}, {108, 108, 152}, {109, 122, 83}, },
            {{48, 115, -47}, {116, 116, 153}, {117, 122, 83}, },
            {{48, 99, -49}, {100, 100, 154}, {101, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 104, -38}, {105, 105, 155}, {106, 107, 83}, {108, 108, 156}, {109, 115, 83}, {116, 116, 157}, {117, 122, 83}, },
            {{48, 109, -54}, {110, 110, 158}, {111, 122, 83}, },
            {{48, 95, -31}, {97, 120, 83}, {121, 121, 159}, {122, 122, 83}, },
            {{48, 95, -31}, {97, 108, 83}, {109, 109, 160}, {110, 117, 83}, {118, 118, 161}, {119, 122, 83}, },
            {{48, 116, -51}, {117, 117, 162}, {118, 122, 83}, },
            {{48, 115, -47}, {116, 116, 163}, {117, 122, 83}, },
            {{48, 90, -31}, {95, 95, 164}, {97, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 90, -31}, {95, 95, 165}, {97, 122, 83}, },
            {{48, 99, -49}, {100, 100, 166}, {101, 122, 83}, },
            {{48, 104, -38}, {105, 105, 167}, {106, 110, 83}, {111, 111, 168}, {112, 122, 83}, },
            {{48, 109, -54}, {110, 110, 169}, {111, 122, 83}, },
            {{48, 110, -43}, {111, 111, 170}, {112, 122, 83}, },
            {{48, 104, -38}, {105, 105, 171}, {106, 122, 83}, },
            {{48, 108, -112}, {109, 109, 172}, {110, 122, 83}, },
            {{48, 95, -31}, {97, 97, 173}, {98, 116, 83}, {117, 117, 174}, {118, 122, 83}, },
            {{48, 111, -100}, {112, 112, 175}, {113, 122, 83}, },
            {{48, 107, -41}, {108, 108, 176}, {109, 114, 83}, {115, 115, 177}, {116, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {},
            {{0, 65535, -74}, },
            {{0, 65535, -74}, },
            {{0, 9, 129}, {10, 10, 178}, {11, 65535, -74}, },
            {{0, 9, 179}, {10, 10, 180}, {11, 12, 179}, {13, 13, 181}, {14, 41, 179}, {42, 42, 132}, {43, 46, 179}, {47, 47, 182}, {48, 65535, 179}, },
            {{0, 65535, -75}, },
            {},
            {{10, 10, 183}, },
            {{95, 95, 184}, },
            {{100, 100, 185}, },
            {{48, 104, -38}, {105, 105, 186}, {106, 122, 83}, },
            {{48, 100, -46}, {101, 101, 187}, {102, 122, 83}, },
            {{48, 108, -112}, {109, 109, 188}, {110, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 107, -41}, {108, 108, 189}, {109, 122, 83}, },
            {{48, 95, -31}, {97, 97, 190}, {98, 122, 83}, },
            {{48, 100, -46}, {101, 101, 191}, {102, 122, 83}, },
            {{48, 109, -54}, {110, 110, 192}, {111, 122, 83}, },
            {{48, 115, -47}, {116, 116, 193}, {117, 122, 83}, },
            {{48, 100, -46}, {101, 101, 194}, {102, 122, 83}, },
            {{48, 115, -47}, {116, 116, 195}, {117, 122, 83}, },
            {{48, 95, -31}, {97, 97, 83}, {98, 98, 196}, {99, 122, 83}, },
            {{48, 107, -41}, {108, 108, 197}, {109, 122, 83}, },
            {{48, 114, -90}, {115, 115, 198}, {116, 122, 83}, },
            {{48, 107, -41}, {108, 108, 199}, {109, 122, 83}, },
            {{48, 110, -43}, {111, 111, 200}, {112, 122, 83}, },
            {{48, 99, -49}, {100, 100, 201}, {101, 122, 83}, },
            {{48, 115, -47}, {116, 116, 202}, {117, 122, 83}, },
            {{48, 104, -38}, {105, 105, 203}, {106, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 111, -100}, {112, 112, 204}, {113, 122, 83}, },
            {{48, 111, -100}, {112, 112, 205}, {113, 122, 83}, },
            {{48, 100, -46}, {101, 101, 206}, {102, 122, 83}, },
            {{48, 107, -41}, {108, 108, 207}, {109, 122, 83}, },
            {{48, 113, -55}, {114, 114, 208}, {115, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 95, -31}, {97, 117, 83}, {118, 118, 209}, {119, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 109, -54}, {110, 110, 210}, {111, 111, 211}, {112, 122, 83}, },
            {{48, 98, -37}, {99, 99, 212}, {100, 117, 83}, {118, 118, 213}, {119, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 113, -55}, {114, 114, 214}, {115, 118, 83}, {119, 119, 215}, {120, 122, 83}, },
            {{48, 111, -100}, {112, 112, 216}, {113, 122, 83}, },
            {{48, 100, -46}, {101, 101, 217}, {102, 122, 83}, },
            {{48, 98, -37}, {99, 99, 218}, {100, 122, 83}, },
            {{48, 100, -46}, {101, 101, 219}, {102, 122, 83}, },
            {{48, 100, -46}, {101, 101, 220}, {102, 122, 83}, },
            {{48, 100, -46}, {101, 101, 221}, {102, 122, 83}, },
            {{48, 104, -38}, {105, 105, 222}, {106, 122, 83}, },
            {{0, 65535, -74}, },
            {{0, 9, 223}, {10, 10, 224}, {11, 12, 223}, {13, 13, 225}, {14, 41, 223}, {42, 42, 226}, {43, 65535, 223}, },
            {{0, 65535, -181}, },
            {{0, 9, 223}, {10, 10, 227}, {11, 65535, -181}, },
            {},
            {},
            {{112, 112, 228}, },
            {},
            {{48, 117, -167}, {118, 118, 229}, {119, 122, 83}, },
            {{48, 113, -55}, {114, 114, 230}, {115, 122, 83}, },
            {{48, 104, -38}, {105, 105, 231}, {106, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 95, -31}, {97, 106, 83}, {107, 107, 232}, {108, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 100, -46}, {101, 101, 233}, {102, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 120, -111}, {121, 121, 234}, {122, 122, 83}, },
            {{48, 107, -41}, {108, 108, 235}, {109, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 100, -46}, {101, 101, 236}, {102, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 100, -46}, {101, 101, 237}, {102, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 109, -54}, {110, 110, 238}, {111, 122, 83}, },
            {{48, 100, -46}, {101, 101, 239}, {102, 122, 83}, },
            {{48, 115, -47}, {116, 116, 240}, {117, 122, 83}, },
            {{48, 113, -55}, {114, 114, 241}, {115, 122, 83}, },
            {{48, 107, -41}, {108, 108, 242}, {109, 122, 83}, },
            {{48, 95, -31}, {97, 97, 243}, {98, 122, 83}, },
            {{48, 95, -31}, {97, 97, 244}, {98, 122, 83}, },
            {{48, 115, -47}, {116, 116, 245}, {117, 122, 83}, },
            {{48, 113, -55}, {114, 114, 246}, {115, 122, 83}, },
            {{48, 115, -47}, {116, 116, 247}, {117, 122, 83}, },
            {{48, 104, -38}, {105, 105, 248}, {106, 122, 83}, },
            {{48, 115, -47}, {116, 116, 249}, {117, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 110, -43}, {111, 111, 250}, {112, 122, 83}, },
            {{48, 100, -46}, {101, 101, 251}, {102, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 99, -49}, {100, 100, 252}, {101, 122, 83}, },
            {{48, 114, -90}, {115, 115, 253}, {116, 122, 83}, },
            {{48, 95, -31}, {97, 102, 83}, {103, 103, 254}, {104, 122, 83}, },
            {{0, 65535, -181}, },
            {{0, 65535, -181}, },
            {{0, 9, 223}, {10, 10, 255}, {11, 65535, -181}, },
            {{0, 41, -134}, {42, 42, 226}, {43, 65535, -134}, },
            {{0, 65535, -181}, },
            {{114, 114, 256}, },
            {{48, 100, -46}, {101, 101, 257}, {102, 122, 83}, },
            {{48, 115, -47}, {116, 116, 258}, {117, 122, 83}, },
            {{48, 98, -37}, {99, 99, 259}, {100, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 111, -100}, {112, 112, 260}, {113, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 100, -46}, {101, 101, 261}, {102, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 109, -54}, {110, 110, 262}, {111, 122, 83}, },
            {{48, 100, -46}, {101, 101, 263}, {102, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 120, -111}, {121, 121, 264}, {122, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 98, -37}, {99, 99, 265}, {100, 122, 83}, },
            {{48, 107, -41}, {108, 108, 266}, {109, 122, 83}, },
            {{48, 101, -45}, {102, 102, 267}, {103, 108, 83}, {109, 109, 268}, {110, 122, 83}, },
            {{48, 104, -38}, {105, 105, 269}, {106, 122, 83}, },
            {{48, 120, -111}, {121, 121, 270}, {122, 122, 83}, },
            {{48, 99, -49}, {100, 100, 271}, {101, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 116, -51}, {117, 117, 272}, {118, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 100, -46}, {101, 101, 273}, {102, 122, 83}, },
            {{48, 114, -90}, {115, 115, 274}, {116, 122, 83}, },
            {{48, 109, -54}, {110, 110, 275}, {111, 122, 83}, },
            {{0, 65535, -181}, },
            {},
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 99, -49}, {100, 100, 276}, {101, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 100, -46}, {101, 101, 277}, {102, 122, 83}, },
            {{48, 116, -51}, {117, 117, 278}, {118, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 115, -47}, {116, 116, 279}, {117, 122, 83}, },
            {{48, 111, -100}, {112, 112, 280}, {113, 122, 83}, },
            {{48, 100, -46}, {101, 101, 281}, {102, 122, 83}, },
            {{48, 115, -47}, {116, 116, 282}, {117, 122, 83}, },
            {{48, 101, -45}, {102, 102, 283}, {103, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 100, -46}, {101, 101, 284}, {102, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 100, -46}, {101, 101, 285}, {102, 122, 83}, },
            {{48, 120, -111}, {121, 121, 286}, {122, 122, 83}, },
            {{48, 100, -46}, {101, 101, 287}, {102, 122, 83}, },
            {{48, 99, -49}, {100, 100, 288}, {101, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 99, -49}, {100, 100, 289}, {101, 122, 83}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {0, 94, 0, 0, 0, 0, 0, 4, 39, 26, 6, 11, 41, 19, 20, 6, 7, 27, 8, 28, 6, 3, 31, 25, 16, 29, 17, 37, 40, 93, 23, 42, 24, 13, 38, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 21, 12, 22, 5, 0, 0, 0, 0, 0, 0, 35, 10, -1, 95, 14, 32, 33, 34, -1, 2, 3, 30, 9, 18, 10, 18, 9, 36, 93, 93, 93, -1, -1, 93, 93, 93, 93, 93, 93, 93, 93, 93, 53, 93, 93, 93, 93, 93, 58, 93, 93, 93, 61, 93, 93, 93, 93, 93, 93, 93, 69, 70, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 91, 92, 15, -1, -1, -1, -1, 2, 2, 2, -1, -1, 93, 93, 93, 46, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 63, 64, 93, 93, 93, 93, 93, 68, 93, 72, 93, 93, 81, 93, 93, 93, 93, 93, 93, 93, 93, -1, -1, -1, -1, 1, 2, -1, 76, 93, 93, 93, 47, 93, 49, 51, 93, 54, 93, 93, 56, 93, 50, 59, 93, 62, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 83, 84, 93, 93, 87, 93, 93, 93, -1, -1, -1, -1, -1, -1, 93, 93, 93, 48, 93, 50, 93, 57, 93, 93, 65, 93, 66, 50, 93, 93, 93, 93, 93, 93, 82, 93, 86, 93, 93, 93, -1, 77, 43, 44, 45, 52, 93, 60, 78, 50, 93, 93, 73, 74, 93, 93, 93, 93, 93, 89, 93, 55, 67, 93, 93, 93, 93, 85, 88, 93, 71, 75, 79, 80, 90, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(@SuppressWarnings("hiding") int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
